# Modelur Number Input

This project provides a hook and component for number input with specific behavior.

## Hook

The provided [React hook](https://react.dev/learn/reusing-logic-with-custom-hooks#extracting-your-own-custom-hook-from-a-component) for number input based on 
[Chakra-UI](https://chakra-ui.com) and [useNumberInput](https://github.com/chakra-ui/chakra-ui/blob/main/packages/components/number-input/src/use-number-input.ts).

The hook implements the following behavior changes from Chakra-ui version:
* [ ] call `onChange` event handler only on the following events
  * [ ] `Enter` key is pressed
  * [ ] cursor is lost from the field (user cliks on other field, or presses `Tab` key)
  * [ ] arrow `Up` or `Down` keys are pressed
  * [ ] mouse wheel is used
  * [ ] stepper elements are pressed
* [ ] pressing `Home` and `End` keys only moves cursor to beginning or end of the number
* [ ] pressing `Tab` moves cursor to the next input

## Component

The repository provides a new [React Function Component](https://react.dev/learn/your-first-component) based on [Chakra-Ui NumberInput](https://chakra-ui.com/docs/components/number-input) that uses the above hook to define behavior.


## Installation
Within a particular ecosystem, there may be a common way of installing things, such as using Yarn, NuGet, or Homebrew. However, consider the possibility that whoever is reading your README is a novice and would like more guidance. Listing specific steps helps remove ambiguity and gets people to using your project as quickly as possible. If it only runs in a specific context like a particular programming language version or operating system or has dependencies that have to be installed manually, also add a Requirements subsection.

## Usage
Use examples liberally, and show the expected output if you can. It's helpful to have inline the smallest example of usage that you can demonstrate, while providing links to more sophisticated examples if they are too long to reasonably include in the README.

## Support
Tell people where they can go to for help. It can be any combination of an issue tracker, a chat room, an email address, etc.

## Roadmap
If you have ideas for releases in the future, it is a good idea to list them in the README.

## Contributing
State if you are open to contributions and what your requirements are for accepting them.

For people who want to make changes to your project, it's helpful to have some documentation on how to get started. Perhaps there is a script that they should run or some environment variables that they need to set. Make these steps explicit. These instructions could also be useful to your future self.

You can also document commands to lint the code or run tests. These steps help to ensure high code quality and reduce the likelihood that the changes inadvertently break something. Having instructions for running tests is especially helpful if it requires external setup, such as starting a Selenium server for testing in a browser.

## Authors and acknowledgment
Show your appreciation to those who have contributed to the project.

## License
For open source projects, say how it is licensed.

## Project status
If you have run out of energy or time for your project, put a note at the top of the README saying that development has slowed down or stopped completely. Someone may choose to fork your project or volunteer to step in as a maintainer or owner, allowing your project to keep going. You can also make an explicit request for maintainers.
